CREATE OR REPLACE TRIGGER LOG_ATE_PLANOVOO
AFTER UPDATE OR INSERT OR DELETE
ON PLANOVOO  FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_TIPO       := '0';
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFili=' ||:OLD.CDFILIAL;
      END IF;
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCia=' ||:OLD.CDCIA;
      END IF;
      IF :OLD.NRVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' NrVoo=' ||:OLD.NRVOO;
      END IF;
      IF :OLD.CDTRECHO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTrecho=' ||:OLD.CDTRECHO;
      END IF;
      IF :OLD.DTHRPLAVOOPV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrPlaVoo=' ||:OLD.DTHRPLAVOOPV;
      END IF;
      IF :OLD.CDEQUIP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdEquip=' ||:OLD.CDEQUIP;
      END IF;   
      IF :OLD.SGPREFIXO IS NOT NULL THEN
         V_DESC := V_DESC || ' SgPrefixo=' ||:OLD.SGPREFIXO;
      END IF;
      IF :OLD.HRPREVDECPV IS NOT NULL THEN
         V_DESC := V_DESC || ' HrPrevDec=' ||:OLD.HRPREVDECPV;
      END IF;
      IF :OLD.HRPREVPOUPV IS NOT NULL THEN
         V_DESC := V_DESC || ' HrPrevPou=' ||:OLD.HRPREVPOUPV;
      END IF;
      IF :OLD.QTHRKDTCARPV IS NOT NULL THEN
         V_DESC := V_DESC || ' QtHrKdtCar=' ||:OLD.QTHRKDTCARPV;
      END IF;
      IF :OLD.QTHRKDTDESPV IS NOT NULL THEN
         V_DESC := V_DESC || ' QtHrKdtDes=' ||:OLD.QTHRKDTDESPV;
      END IF;
      IF :OLD.DTHRABASTPV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrAbast=' ||:OLD.DTHRABASTPV;
      END IF;
      IF :OLD.IDSITABASPV IS NOT NULL THEN
         V_DESC := V_DESC || ' IdSitAbas=' ||:OLD.IDSITABASPV;
      END IF;
      IF :OLD.IDSTKDTABAPV IS NOT NULL THEN
         V_DESC := V_DESC || ' IdStKdtAbas=' ||:OLD.IDSTKDTABAPV;
      END IF;
      IF :OLD.DTHRINCPV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrInc=' ||:OLD.DTHRINCPV;
      END IF;
      IF :OLD.DTHRCANCPV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrCan=' ||:OLD.DTHRCANCPV;
      END IF;
      IF :OLD.CDUSRRESPPV IS NOT NULL THEN
         V_DESC := V_DESC || ' CdUsrResp=' ||:OLD.CDUSRRESPPV;
      END IF;
      IF :OLD.CDPOSPISTAPV IS NOT NULL THEN
         V_DESC := V_DESC || ' CdPosPista=' ||:OLD.CDPOSPISTAPV;
      END IF;   
      IF :OLD.IDBREAKGERA IS NOT NULL THEN
         V_DESC := V_DESC || ' IdBrkGer=' ||:OLD.IDBREAKGERA;
      END IF;
      IF :OLD.IDTPPREVISAO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTpPrev=' ||:OLD.IDTPPREVISAO;
      END IF;
      IF :OLD.TXOBSUSRPV IS NOT NULL THEN
         V_DESC := V_DESC || ' TxObsUsr=' ||:OLD.TXOBSUSRPV;
      END IF;
      IF :OLD.IDREGERACAO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdReger=' ||:OLD.IDREGERACAO;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDFILIAL||'|'||:OLD.CDCIA||'|'||:OLD.NRVOO||'|'||:OLD.CDTRECHO||'|'||:OLD.DTHRPLAVOOPV;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDFILIAL,'!')          <> NVL(:NEW.CDFILIAL,'!'))          OR
            (NVL(:OLD.CDCIA,'!')             <> NVL(:NEW.CDCIA,'!'))             OR
            (NVL(:OLD.NRVOO,'!')             <> NVL(:NEW.NRVOO,'!'))             OR
            (NVL(:OLD.CDTRECHO,'!')          <> NVL(:NEW.CDTRECHO,'!'))          OR
            (NVL(:OLD.DTHRPLAVOOPV, SYSDATE) <> NVL(:NEW.DTHRPLAVOOPV, SYSDATE)) OR
            (NVL(:OLD.CDEQUIP,'!')           <> NVL(:NEW.CDEQUIP,'!'))           OR
            (NVL(:OLD.SGPREFIXO,'!')         <> NVL(:NEW.SGPREFIXO,'!'))         OR
            (NVL(:OLD.HRPREVDECPV,'!')       <> NVL(:NEW.HRPREVDECPV,'!'))       OR
            (NVL(:OLD.HRPREVPOUPV,'!')       <> NVL(:NEW.HRPREVPOUPV,'!'))       OR
            (NVL(:OLD.QTHRKDTCARPV,'!')      <> NVL(:NEW.QTHRKDTCARPV,'!'))      OR
            (NVL(:OLD.QTHRKDTDESPV,'!')      <> NVL(:NEW.QTHRKDTDESPV,'!'))      OR
            (NVL(:OLD.DTHRABASTPV, SYSDATE)  <> NVL(:NEW.DTHRABASTPV, SYSDATE))  OR
            (NVL(:OLD.IDSITABASPV,'!')       <> NVL(:NEW.IDSITABASPV,'!'))       OR
            (NVL(:OLD.IDSTKDTABAPV,'!')      <> NVL(:NEW.IDSTKDTABAPV,'!'))      OR
            (NVL(:OLD.DTHRINCPV, SYSDATE)    <> NVL(:NEW.DTHRINCPV, SYSDATE))    OR
            (NVL(:OLD.DTHRCANCPV, SYSDATE)   <> NVL(:NEW.DTHRCANCPV, SYSDATE))   OR
            (NVL(:OLD.CDUSRRESPPV,'!')       <> NVL(:NEW.CDUSRRESPPV,'!'))       OR
            (NVL(:OLD.CDPOSPISTAPV,'!')      <> NVL(:NEW.CDPOSPISTAPV,'!'))      OR
            (NVL(:OLD.IDBREAKGERA,'!')       <> NVL(:NEW.IDBREAKGERA,'!'))       OR
            (NVL(:OLD.IDTPPREVISAO,'!')      <> NVL(:NEW.IDTPPREVISAO,'!'))      OR
            (NVL(:OLD.TXOBSUSRPV,'!')        <> NVL(:NEW.TXOBSUSRPV,'!'))        OR
            (NVL(:OLD.IDREGERACAO,'!')       <> NVL(:NEW.IDREGERACAO,'!'))       THEN
            
            IF (NVL(:NEW.CDFILIAL,'!') <> NVL(:OLD.CDFILIAL,'!')) THEN
               V_DESC := V_DESC || ' CdFili=' ||:NEW.CDFILIAL;
            END IF;
            IF (NVL(:NEW.CDCIA,'!') <> NVL(:OLD.CDCIA,'!')) THEN
               V_DESC := V_DESC || ' CdCia=' ||:NEW.CDCIA;
            END IF;
            IF (NVL(:NEW.NRVOO,'!') <> NVL(:OLD.NRVOO,'!')) THEN
               V_DESC := V_DESC || ' NrVoo=' ||:NEW.NRVOO;
            END IF;
            IF (NVL(:NEW.CDTRECHO,'!') <> NVL(:OLD.CDTRECHO,'!')) THEN
               V_DESC := V_DESC || ' CdTrecho=' ||:NEW.CDTRECHO;
            END IF;
            IF (NVL(:NEW.DTHRPLAVOOPV, SYSDATE) <> NVL(:OLD.DTHRPLAVOOPV, SYSDATE)) THEN
               V_DESC := V_DESC || ' DtHrPlaVoo=' ||:NEW.DTHRPLAVOOPV;
            END IF;
            IF (NVL(:NEW.CDEQUIP,'!') <> NVL(:OLD.CDEQUIP,'!')) THEN
               V_DESC := V_DESC || ' CdEquip=' ||:NEW.CDEQUIP;
            END IF;   
            IF (NVL(:NEW.SGPREFIXO,'!') <> NVL(:OLD.SGPREFIXO,'!')) THEN
               V_DESC := V_DESC || ' SgPrefixo=' ||:NEW.SGPREFIXO;
            END IF;
            IF (NVL(:NEW.HRPREVDECPV,'!') <> NVL(:OLD.HRPREVDECPV,'!')) THEN
               V_DESC := V_DESC || ' HrPrevDec=' ||:NEW.HRPREVDECPV;
            END IF;
            IF (NVL(:NEW.HRPREVPOUPV,'!') <> NVL(:OLD.HRPREVPOUPV,'!')) THEN
               V_DESC := V_DESC || ' HrPrevPou=' ||:NEW.HRPREVPOUPV;
            END IF;
            IF (NVL(:NEW.QTHRKDTCARPV,'!') <> NVL(:OLD.QTHRKDTCARPV,'!')) THEN
               V_DESC := V_DESC || ' QtHrKdtCar=' ||:NEW.QTHRKDTCARPV;
            END IF;
            IF (NVL(:NEW.QTHRKDTDESPV,'!') <> NVL(:OLD.QTHRKDTDESPV,'!')) THEN
               V_DESC := V_DESC || ' QtHrKdtDes=' ||:NEW.QTHRKDTDESPV;
            END IF;
            IF (NVL(:NEW.DTHRABASTPV, SYSDATE) <> NVL(:OLD.DTHRABASTPV, SYSDATE)) THEN
               V_DESC := V_DESC || ' DtHrAbast=' ||:NEW.DTHRABASTPV;
            END IF;
            IF (NVL(:NEW.IDSITABASPV,'!') <> NVL(:OLD.IDSITABASPV,'!')) THEN
               V_DESC := V_DESC || ' IdSitAbas=' ||:NEW.IDSITABASPV;
            END IF;
            IF (NVL(:NEW.IDSTKDTABAPV,'!') <> NVL(:OLD.IDSTKDTABAPV,'!')) THEN
               V_DESC := V_DESC || ' IdStKdtAbas=' ||:NEW.IDSTKDTABAPV;
            END IF;
            IF (NVL(:NEW.DTHRINCPV, SYSDATE) <> NVL(:OLD.DTHRINCPV, SYSDATE)) THEN
               V_DESC := V_DESC || ' DtHrInc=' ||:NEW.DTHRINCPV;
            END IF;
            IF (NVL(:NEW.DTHRCANCPV, SYSDATE) <> NVL(:OLD.DTHRCANCPV, SYSDATE)) THEN
               V_DESC := V_DESC || ' DtHrCan=' ||:NEW.DTHRCANCPV;
            END IF;
            IF (NVL(:NEW.CDUSRRESPPV,'!') <> NVL(:OLD.CDUSRRESPPV,'!')) THEN
               V_DESC := V_DESC || ' CdUsrResp=' ||:NEW.CDUSRRESPPV;
            END IF;
            IF (NVL(:NEW.CDPOSPISTAPV,'!') <> NVL(:OLD.CDPOSPISTAPV,'!')) THEN
               V_DESC := V_DESC || ' CdPosPista=' ||:NEW.CDPOSPISTAPV;
            END IF;   
            IF (NVL(:NEW.IDBREAKGERA,'!') <> NVL(:OLD.IDBREAKGERA,'!')) THEN
               V_DESC := V_DESC || ' IdBrkGer=' ||:NEW.IDBREAKGERA;
            END IF;
            IF (NVL(:NEW.IDTPPREVISAO,'!') <> NVL(:OLD.IDTPPREVISAO,'!')) THEN
               V_DESC := V_DESC || ' IdTpPrev=' ||:NEW.IDTPPREVISAO;
            END IF;
            IF (NVL(:NEW.TXOBSUSRPV,'!') <> NVL(:OLD.TXOBSUSRPV,'!')) THEN
               V_DESC := V_DESC || ' TxObsUsr=' ||:NEW.TXOBSUSRPV;
            END IF;
            IF (NVL(:NEW.IDREGERACAO,'!') <> NVL(:OLD.IDREGERACAO,'!')) THEN
               V_DESC := V_DESC || ' IdReger=' ||:NEW.IDREGERACAO;
            END IF;
            
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL||'|'||:OLD.CDCIA||'|'||:OLD.NRVOO||'|'||:OLD.CDTRECHO||'|'||:OLD.DTHRPLAVOOPV;
         END IF;
      ELSE
         IF (NVL(:NEW.CDFILIAL,'!') <> NVL(:OLD.CDFILIAL,'!')) THEN
            V_DESC := V_DESC || ' CdFili=' ||:NEW.CDFILIAL;
         END IF;
         IF (NVL(:NEW.CDCIA,'!') <> NVL(:OLD.CDCIA,'!')) THEN
            V_DESC := V_DESC || ' CdCia=' ||:NEW.CDCIA;
         END IF;
         IF (NVL(:NEW.NRVOO,'!') <> NVL(:OLD.NRVOO,'!')) THEN
            V_DESC := V_DESC || ' NrVoo=' ||:NEW.NRVOO;
         END IF;
         IF (NVL(:NEW.CDTRECHO,'!') <> NVL(:OLD.CDTRECHO,'!')) THEN
            V_DESC := V_DESC || ' CdTrecho=' ||:NEW.CDTRECHO;
         END IF;
         IF (NVL(:NEW.DTHRPLAVOOPV, SYSDATE) <> NVL(:OLD.DTHRPLAVOOPV, SYSDATE)) THEN
            V_DESC := V_DESC || ' DtHrPlaVoo=' ||:NEW.DTHRPLAVOOPV;
         END IF;
         IF (NVL(:NEW.CDEQUIP,'!') <> NVL(:OLD.CDEQUIP,'!')) THEN
            V_DESC := V_DESC || ' CdEquip=' ||:NEW.CDEQUIP;
         END IF;   
         IF (NVL(:NEW.SGPREFIXO,'!') <> NVL(:OLD.SGPREFIXO,'!')) THEN
            V_DESC := V_DESC || ' SgPrefixo=' ||:NEW.SGPREFIXO;
         END IF;
         IF (NVL(:NEW.HRPREVDECPV,'!') <> NVL(:OLD.HRPREVDECPV,'!')) THEN
            V_DESC := V_DESC || ' HrPrevDec=' ||:NEW.HRPREVDECPV;
         END IF;
         IF (NVL(:NEW.HRPREVPOUPV,'!') <> NVL(:OLD.HRPREVPOUPV,'!')) THEN
            V_DESC := V_DESC || ' HrPrevPou=' ||:NEW.HRPREVPOUPV;
         END IF;
         IF (NVL(:NEW.QTHRKDTCARPV,'!') <> NVL(:OLD.QTHRKDTCARPV,'!')) THEN
            V_DESC := V_DESC || ' QtHrKdtCar=' ||:NEW.QTHRKDTCARPV;
         END IF;
         IF (NVL(:NEW.QTHRKDTDESPV,'!') <> NVL(:OLD.QTHRKDTDESPV,'!')) THEN
            V_DESC := V_DESC || ' QtHrKdtDes=' ||:NEW.QTHRKDTDESPV;
         END IF;
         IF (NVL(:NEW.DTHRABASTPV, SYSDATE) <> NVL(:OLD.DTHRABASTPV, SYSDATE)) THEN
            V_DESC := V_DESC || ' DtHrAbast=' ||:NEW.DTHRABASTPV;
         END IF;
         IF (NVL(:NEW.IDSITABASPV,'!') <> NVL(:OLD.IDSITABASPV,'!')) THEN
            V_DESC := V_DESC || ' IdSitAbas=' ||:NEW.IDSITABASPV;
         END IF;
         IF (NVL(:NEW.IDSTKDTABAPV,'!') <> NVL(:OLD.IDSTKDTABAPV,'!')) THEN
            V_DESC := V_DESC || ' IdStKdtAbas=' ||:NEW.IDSTKDTABAPV;
         END IF;
         IF (NVL(:NEW.DTHRINCPV, SYSDATE) <> NVL(:OLD.DTHRINCPV, SYSDATE)) THEN
            V_DESC := V_DESC || ' DtHrInc=' ||:NEW.DTHRINCPV;
         END IF;
         IF (NVL(:NEW.DTHRCANCPV, SYSDATE) <> NVL(:OLD.DTHRCANCPV, SYSDATE)) THEN
            V_DESC := V_DESC || ' DtHrCan=' ||:NEW.DTHRCANCPV;
         END IF;
         IF (NVL(:NEW.CDUSRRESPPV,'!') <> NVL(:OLD.CDUSRRESPPV,'!')) THEN
            V_DESC := V_DESC || ' CdUsrResp=' ||:NEW.CDUSRRESPPV;
         END IF;
         IF (NVL(:NEW.CDPOSPISTAPV,'!') <> NVL(:OLD.CDPOSPISTAPV,'!')) THEN
            V_DESC := V_DESC || ' CdPosPista=' ||:NEW.CDPOSPISTAPV;
         END IF;   
         IF (NVL(:NEW.IDBREAKGERA,'!') <> NVL(:OLD.IDBREAKGERA,'!')) THEN
            V_DESC := V_DESC || ' IdBrkGer=' ||:NEW.IDBREAKGERA;
         END IF;
         IF (NVL(:NEW.IDTPPREVISAO,'!') <> NVL(:OLD.IDTPPREVISAO,'!')) THEN
            V_DESC := V_DESC || ' IdTpPrev=' ||:NEW.IDTPPREVISAO;
         END IF;
         IF (NVL(:NEW.TXOBSUSRPV,'!') <> NVL(:OLD.TXOBSUSRPV,'!')) THEN
            V_DESC := V_DESC || ' TxObsUsr=' ||:NEW.TXOBSUSRPV;
         END IF;
         IF (NVL(:NEW.IDREGERACAO,'!') <> NVL(:OLD.IDREGERACAO,'!')) THEN
            V_DESC := V_DESC || ' IdReger=' ||:NEW.IDREGERACAO;
         END IF;
         
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL||'|'||:NEW.CDCIA||'|'||:NEW.NRVOO||'|'||:NEW.CDTRECHO||'|'||:NEW.DTHRPLAVOOPV;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 300);
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA, DTOPERACAO, NMRESPOPER, IDTIPOOPER, DSOPERACAO, CDPESQITEM,
             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
         VALUES
            ('PLANOVOO', SYSDATE, NVL(V_NMOPERADOR,' '), V_TIPO, V_DESC, V_ITPESQ,
             V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ATE_PLANOVOO','5.85.xxx'); END;
/ 